unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  StdCtrls, Gauges, ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    Button1: TButton;
    Gauge1: TGauge;
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
    CodeGuruC3659, FileCtrl, otff;

//  http://www.h2.dion.ne.jp/~landhere/delphi/file.htm
//  t@CăXg쐬(TutH_[)(
//  List : t@C̃Xgi[ꏊ
//  Path : tH_
//  Filter : t@C̃ChJ[h\
//  Level : Kw
//  <res> : Yt@Č
function GetFileListEx(List: TStrings; Path,Filter: String; Level: Integer): Integer;
var
  sr: TSearchRec;
  rs: Integer;
  ct: Integer;
begin
  Dec(Level);
  if Level<0 then begin
    Result:=0;
    exit;
  end;

  ct:=0;

  //tH_[
  rs:=FindFirst(IncludeTrailingPathDelimiter(Path)+'*.*',faDirectory,sr);
  try
    while rs=0 do begin
      if (sr.Name<>'.') and (sr.Name<>'..') and (DirectoryExists(IncludeTrailingPathDelimiter(Path)+sr.Name)) then begin
        ct:=ct+GetFileListEx(List,IncludeTrailingPathDelimiter(Path)+sr.Name,Filter,Level);
      end;
      rs:=FindNext(sr);
    end;
  finally
    FindClose(sr);
  end;

  //ʏt@C
  rs:=FindFirst(IncludeTrailingPathDelimiter(Path)+Filter,faAnyFile,sr);
  try
    while rs=0 do begin
      List.Add(IncludeTrailingPathDelimiter(Path)+sr.Name);
      Inc(ct);
      rs:=FindNext(sr);
    end;
  finally
    FindClose(sr);
  end;

  Result:=ct;
end;


procedure TForm1.Button1Click(Sender: TObject);
var
    Dir: string;
    SL, SL2: TStringList;
    i: integer;
    Ret: string;
    FontName: string;
begin
    if SelectDirectory('tHĝςtH_', '', Dir) then
    begin
        Memo1.Clear();
        SL := TStringList.Create;
        SL2 := TStringList.Create;
        try
            Screen.Cursor := crHourGlass;
            //  3Kw܂ŗ
            GetFileListEx(SL, Dir, '*.tt*', 3);
            //  Q[Wݒ
            Gauge1.MaxValue := SL.Count;
            Gauge1.Progress := 0;
            //  tHgɕϊ
            for i := 0 to SL.Count - 1 do
            begin
                FontName := SL[i];
                //  .ttf ̏ꍇ
                if (LowerCase(ExtractFileExt(FontName)) = '.ttf') then
                begin
                    Ret := GetFontNameFromFile(FontName);
                end
                //  .ttc ̏ꍇ
                else if (LowerCase(ExtractFileExt(FontName)) = '.ttc') then
                begin
                    SL2.Clear;
                    GetFontNameFromTTC(FontName, SL2);
                    Ret := SL2.CommaText;
                end;
                Memo1.Lines.Add(Format('%s', [ExtractFileName(FontName)]));
                Memo1.Lines.Add(Format('   >> %s', [Ret]));
                Memo1.Lines.Add('');
                Gauge1.Progress := Gauge1.Progress + 1;
            end;
        finally
            SL.Free;
            SL2.Free;
            Screen.Cursor := crDefault;
        end;
    end;
end;

end.

